<?php

// URL obfuscating script
// Author: Gregory Watts (www.greg-tools.com/pmwiki/)


if (!$UrlWhiteList) $UrlWhiteList = array();
if (!$RedirectionScriptUrl) $RedirectionScriptUrl = "/pmwiki/redirect.php";

$FmtUrlLink = 'GWFmtUrlLink';

function encode_url($url) {
	$visiblechars = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_-';

	// legth of $url should be a multiple of 2 to avoid conding flaw
	if (strlen($url) % 2) $url .= ' ';
	$bin = '';
	for ($i = 0; $i < strlen($url); $i++) {
		$ch = substr($url, $i, 1);
		$dec = ord($ch);
		$bin .= str_pad(decbin($dec),8,"0",STR_PAD_LEFT);
	}

	// Take the string 6bits by 6bits and rewrite it in ascii
	$m = strlen($bin) / 6;
	$out = '';
	for ($i = 0; $i < $m ; $i++) {
		$b = substr($bin, $i *6, 6);
		$v = bindec($b);
		$r = substr($visiblechars, $v, 1);
		// echo "$b -> $v = $r\n";
		$out .= $r;
	}
	return $out;
}


function rewrite_url($url,$text) {
	// globals from pmwiki
	global $UrlMethodPattern;

	// globals specific to this function
	global $RedirectionScriptUrl, $UrlWhiteList;

	// Check the site pointed by the url against the whitelist
	$search = "/($UrlMethodPattern):\/\/(.*?)[\/$]/i";
	preg_match($search, $url, $match);
	$site_name = $match[2];
	foreach ($UrlWhiteList as $wlItem) {
		if ($wlItem == $site_name) {
			// found in whitelist: don't rewrite url
			//echo "<!-- Found in whitelist: $wlItem -->\n";
			$new_url=array('url' => $url, 'text' => $text);
			return $new_url;
		}
	}
	
	// not in white list, obfuscate url
	$out = $RedirectionScriptUrl.'?link=' . encode_url($url);
	//echo "coded url: $out \n";
	$search="/http:\/\/(.*?)\.(.*?)\..*/i";
	preg_match($search, $text, $match);
	$link_text = ($match[2] != '') ? $match[2] : $text;
			
	$new_url=array('url' => $out, 'text' => $link_text);
	
        return $new_url;
}

function GWFmtUrlLink($pat,$ref,$txt) {
  global $InterMapUrls,$ImgExtPattern,$UrlLinkFmt,$UrlImgFmt,$UrlLinkTextFmt;
  $link = $UrlLinkFmt; $rtxt=$ref;
  if (!is_null($txt)) { $rtxt=$txt; $link=$UrlLinkTextFmt; }
  elseif (preg_match("/$ImgExtPattern\$/",$ref)) { $link=$UrlImgFmt; }
  if (preg_match('/^([^:]*):/',$ref,$match)) {
    if (@$InterMapUrls[$match[1]]) 
      $ref=preg_replace("/^$pat\$/",$InterMapUrls[$match[1]],$ref);
  }
  
  $new_url =  rewrite_url($ref, $rtxt);
  $ref = $new_url['url'];
  $rtxt = $new_url['text'];

  $link = str_replace('$Url',$ref,$link);
  return  str_replace('$LinkText',$rtxt,$link);
}


?>
